<?

function setaccountcode_destinations() {
	global $module_page;

	// it makes no sense to point at another callerid (and it can be an infinite loop)
	if ($module_page == 'setaccountcode') {
		return false;
	}

	// return an associative array with destination and description
	foreach (setaccountcode_list() as $row) {
		$extens[] = array('destination' => 'app-setaccountcode,' . $row['cac_id'] . ',1', 'description' => $row['description']);
	}
	return $extens;
}

function setaccountcode_getdest($exten) {
	return array('app-setaccountcode,'.$exten.',1');
}

function setaccountcode_getdestinfo($dest) {
	global $active_modules;

	if (substr(trim($dest),0,14) == 'app-setaccountcode,') {
		$exten = explode(',',$dest);
		$exten = $exten[1];
		$thisexten = setaccountcode_get($exten);
		if (empty($thisexten)) {
			return array();
		} else {
			$type = isset($active_modules['setaccountcode']['type'])?$active_modules['setaccountcode']['type']:'setup';
			return array('description' => 'Accountcodeid_name : '.$thisexten['description'],
			             'edit_url' => 'config.php?display=setaccountcode&type='.$type.'&extdisplay='.urlencode($exten),
								  );
		}
	} else {
		return false;
	}
}

function setaccountcode_get_config($engine) {
	global $ext;
	switch ($engine) {
		case 'asterisk':
			$ext->addInclude('from-internal-additional', 'app-setaccountcode');
			foreach (setaccountcode_list() as $row) {
				$ext->add('app-setaccountcode',$row['cac_id'], '', new ext_set('CDR(accountcode)', $row['cac_num']));
          			$ext->add('app-setaccountcode',$row['cac_id'], '', new ext_goto($row['dest']));
			}
		break;
	}
}

/**  Get a list of all cid
 */
function setaccountcode_list() {
	global $db;
	$sql = "SELECT cac_id, description, cac_name, cac_num, dest FROM setaccountcode ORDER BY description ";
	$results = $db->getAll($sql, DB_FETCHMODE_ASSOC);
	if(DB::IsError($results)) {
		die_freepbx($results->getMessage()."<br><br>Error selecting from setaccountcode");	
	}
	return $results;
}

function setaccountcode_get($cac_id) {
	global $db;
	$sql = "SELECT cac_id, description, cac_name, cac_num, dest FROM setaccountcode WHERE cac_id = ".$db->escapeSimple($cac_id);
	$row = $db->getRow($sql, DB_FETCHMODE_ASSOC);
	if(DB::IsError($row)) {
		die_freepbx($row->getMessage()."<br><br>Error selecting row from setaccountcode");	
	}
	
	return $row;
}

function setaccountcode_add($description, $cac_name, $cac_num, $dest) {
	global $db;
	$sql = "INSERT INTO setaccountcode (description, cac_name, cac_num, dest) VALUES (".
		"'".$db->escapeSimple($description)."', ".
		"'".$db->escapeSimple($cac_name)."', ".
		"'".$db->escapeSimple($cac_num)."', ".
		"'".$db->escapeSimple($dest)."')";
	$result = $db->query($sql);
	if(DB::IsError($result)) {
		die_freepbx($result->getMessage().$sql);
	}
}

function setaccountcode_delete($cac_id) {
	global $db;
	$sql = "DELETE FROM setaccountcode WHERE cac_id = ".$db->escapeSimple($cac_id);
	$result = $db->query($sql);
	if(DB::IsError($result)) {
		die_freepbx($result->getMessage().$sql);
	}
}

function setaccountcode_edit($cac_id, $description, $cac_name, $cac_num, $dest) { 
	global $db;
	$sql = "UPDATE setaccountcode SET ".
		"description = '".$db->escapeSimple($description)."', ".
		"cac_name = '".$db->escapeSimple($cac_name)."', ".
		"cac_num = '".$db->escapeSimple($cac_num)."', ".
		"dest = '".$db->escapeSimple($dest)."' ".
		"WHERE cac_id = ".$db->escapeSimple($cac_id);
	$result = $db->query($sql);
	if(DB::IsError($result)) {
		die_freepbx($result->getMessage().$sql);
	}
}

function setaccountcode_check_destinations($dest=true) {
	global $active_modules;

	$destlist = array();
	if (is_array($dest) && empty($dest)) {
		return $destlist;
	}
	$sql = "SELECT cac_id, dest, description FROM setaccountcode ";
	if ($dest !== true) {
		$sql .= "WHERE dest in ('".implode("','",$dest)."')";
	}
	$results = sql($sql,"getAll",DB_FETCHMODE_ASSOC);

	$type = isset($active_modules['setaccountcode']['type'])?$active_modules['setaccountcode']['type']:'setup';

	foreach ($results as $result) {
		$thisdest = $result['dest'];
		$thisid   = $result['cac_id'];
		$destlist[] = array(
			'dest' => $thisdest,
			'description' => 'Account Code Change: '.$result['description'],
			'edit_url' => 'config.php?display=setaccountcode&type='.$type.'&extdisplay='.urlencode($thisid),
		);
	}
	return $destlist;
}
?>
